/* 
 * Leaflet Panel Layers v0.6.9 - 2016-11-17 
 * 
 * Copyright 2016 Stefano Cudini 
 * stefano.cudini@gmail.com 
 * http://labs.easyblog.it/ 
 * 
 * Licensed under the MIT license. 
 * 
 * Demos: 
 * http://labs.easyblog.it/maps/leaflet-panel-layers/ 
 * 
 * Source: 
 * git@github.com:stefanocudini/leaflet-panel-layers.git 
 * 
 */
(function(){L.Control.PanelLayers=L.Control.Layers.extend({includes:L.Mixin.Events,options:{compact:!1,collapsed:!1,autoZIndex:!0,collapsibleGroups:!1,buildItem:null,title:"",position:"topright"},initialize:function(a,b,c){L.setOptions(this,c),this._layers={},this._groups={},this._items={},this._layersActives=[],this._lastZIndex=0,this._handlingClick=!1,this.className="leaflet-panel-layers";var d,e,f;for(d in a)if(a[d].group&&a[d].layers){f=a[d].collapsed||!1;for(e in a[d].layers)this._addLayer(a[d].layers[e],!1,a[d].group,f)}else this._addLayer(a[d],!1);for(d in b)if(b[d].group&&b[d].layers){f=b[d].collapsed||!1;for(e in b[d].layers)this._addLayer(b[d].layers[e],!0,b[d].group,f)}else this._addLayer(b[d],!0)},onAdd:function(a){for(var b in this._layersActives)a.addLayer(this._layersActives[b]);return L.Control.Layers.prototype.onAdd.call(this,a),this._container},addBaseLayer:function(a,b,c){return a.name=b||a.name||"",this._addLayer(a,!1,c),this._update(),this},addOverlay:function(a,b,c){return a.name=b||a.name||"",this._addLayer(a,!0,c),this._update(),this},removeLayer:function(a){var b=a.hasOwnProperty("layer")?this._layerFromDef(a):a;return this._map.removeLayer(b),L.Control.Layers.prototype.removeLayer.call(this,b),this},clearLayers:function(){for(var a in this._layers)this.removeLayer(this._layers[a])},_layerFromDef:function(a){for(var b in this._layers)if(this._layers[b].name===a.name)return this._layers[b].layer},_update:function(){this._groups={},this._items={},L.Control.Layers.prototype._update.call(this)},_instantiateLayer:function(a){return a instanceof L.Class?a:a.type&&a.args?this._getPath(L,a.type).apply(L,a.args):void 0},_addLayer:function(a,b,c,d){var e=a.hasOwnProperty("layer")?this._instantiateLayer(a.layer):a,f=L.stamp(e);a.active&&this._layersActives.push(e),this._layers[f]=L.Util.extend(a,{overlay:b,group:c,layer:e,collapsed:d}),this.options.autoZIndex&&e.setZIndex&&(this._lastZIndex++,e.setZIndex(this._lastZIndex))},_createItem:function(a){var b,c,d,e=this;if(b=L.DomUtil.create("label",this.className+"-item"),d=this._map.hasLayer(a.layer),a.overlay?(c=L.DomUtil.create("input",this.className+"-selector"),c.type="checkbox",c.defaultChecked=d):c=this._createRadioElement("leaflet-base-layers",d),c.value=L.stamp(a.layer),c._layer=a,L.DomEvent.on(c,"click",function(a){e._onInputClick(),a.target.checked?e.fire("panel:selected",a.target._layer):e.fire("panel:unselected",a.target._layer)},this),b.appendChild(c),a.icon){var f=L.DomUtil.create("i",this.className+"-icon");f.innerHTML=a.icon||"",b.appendChild(f)}var g=L.DomUtil.create("span",this.className+"-title");if(this.options.buildItem){var h=this.options.buildItem.call(this,a);if("string"==typeof h){var i=L.DomUtil.create("div");i.innerHTML=h,g=i.firstChild}else g=h}else g.innerHTML=a.name||"";return b.appendChild(g),this._items[c.value]=b,b},_createRadioElement:function(a,b){var c='<input type="radio" class="'+this.className+'-selector" name="'+a+'"';b&&(c+=' checked="checked"'),c+="/>";var d=document.createElement("div");return d.innerHTML=c,d.firstChild},_addItem:function(a){var b,c=a.overlay?this._overlaysList:this._baseLayersList;if(a.group){if(a.group.hasOwnProperty("name")||(a.group={name:a.group}),!this._groups[a.group.name]){var d=!1;a.collapsed===!0&&(d=!0),this._groups[a.group.name]=this._createGroup(a.group,d)}c.appendChild(this._groups[a.group.name]),c=this._groups[a.group.name]}return b=this._createItem(a),c.appendChild(b),b},_createGroup:function(a,b){var c,d,e,f=L.DomUtil.create("div",this.className+"-group");return this.options.collapsibleGroups&&(L.DomUtil.addClass(f,"collapsible"),e=L.DomUtil.create("i",this.className+"-icon",f),b===!0?e.innerHTML=" + ":e.innerHTML=" - ",L.DomEvent.on(e,"click",function(){L.DomUtil.hasClass(f,"expanded")?(L.DomUtil.removeClass(f,"expanded"),e.innerHTML=" + "):(L.DomUtil.addClass(f,"expanded"),e.innerHTML=" - ")}),b===!1&&L.DomUtil.addClass(f,"expanded")),c=L.DomUtil.create("label",this.className+"-grouplabel",f),d=L.DomUtil.create("span",this.className+"-title",c),d.innerHTML=a.name,f},_onInputClick:function(){var a,b,c,d=this._form.getElementsByClassName(this.className+"-selector"),e=d.length;for(this._handlingClick=!0,a=0;e>a;a++)b=d[a],c=this._layers[b.value],b.checked&&!this._map.hasLayer(c.layer)?this._map.addLayer(c.layer):!b.checked&&this._map.hasLayer(c.layer)&&this._map.removeLayer(c.layer);this._handlingClick=!1,this._refocusOnMap()},_initLayout:function(){var a=this._container=L.DomUtil.create("div",this.className);a.setAttribute("aria-haspopup",!0),L.Browser.touch?L.DomEvent.on(a,"click",L.DomEvent.stopPropagation):L.DomEvent.disableClickPropagation(a).disableScrollPropagation(a);var b=this._form=L.DomUtil.create("form",this.className+"-list");if(this.options.compact||this._map.on("resize",function(a){b.style.height=a.newSize.y+"px"}),this.options.compact?L.DomUtil.addClass(a,"compact"):b.style.height=this._map.getSize().y+"px",this.options.collapsed){L.Browser.android||L.DomEvent.on(a,"mouseover",this._expand,this).on(a,"mouseout",this._collapse,this);var c=this._layersLink=L.DomUtil.create("a",this.className+"-toggle",a);c.href="#",c.title="Layers",L.Browser.touch?L.DomEvent.on(c,"click",L.DomEvent.stop).on(c,"click",this._expand,this):L.DomEvent.on(c,"focus",this._expand,this),this._map.on("click",this._collapse,this)}else this._expand();if(this._baseLayersList=L.DomUtil.create("div",this.className+"-base",b),this._separator=L.DomUtil.create("div",this.className+"-separator",b),this._overlaysList=L.DomUtil.create("div",this.className+"-overlays",b),this.options.compact||L.DomUtil.create("div",this.className+"-margin",b),this.options.title){var d=L.DomUtil.create("label",this.className+"-title");d.innerHTML="<span>"+this.options.title+"</span>",a.appendChild(d)}a.appendChild(b)},_expand:function(){L.DomUtil.addClass(this._container,"expanded")},_collapse:function(){this._container.className=this._container.className.replace("expanded","")},_getPath:function(a,b){var c=b.split("."),d=c.pop(),e=c.length,f=c[0],g=1;if(e>0)for(;(a=a[f])&&e>g;)f=c[g++];return a?a[d]:void 0}}),L.control.panelLayers=function(a,b,c){return new L.Control.PanelLayers(a,b,c)}}).call(this);